// CMOS Camera Contorller (OV7670)
// rfIobt@133.33MHzDDR2 SDRAMgp
// CMOSJoĂrfIo͂UYVYƂ
// VSYNC͐_AHREF_
// clk(50MHz)͂̂܂܎gpāAPCLKDCMŎ󂯂ĎgpB
// IOBɃ}bv郍WbN͂̃gbvW[ɃCX^VG[VB
// SCCBSIO_CSIO_D̒[q͎gpȂ
// YUV-RGBϊsāARGB4rbg̒RHɑ
// sw0 - 1̊ԁACMOSJ̃f[^VGAɕ\B0Ɏ́ACMOSJ̃f[^͖āAŌ̃t[\B
// sw1 - 0̊ԂVGARg[̃AhXDDR2 SDRAMɓ邪A1̎VIÕAhXDDR2 SDRAMɓBVIOAhX^CMOSJ̃f[^Lv`邽
// 2011/11/03 : XeIJɑΉ


`default_nettype none

module CamDisp_Cntrler_DDR2 (sysclk, reset_sw, cam1_vsync, cam1_href, cam1_pclk, cam1_data, cam1_clk, cam1_sio_c, cam1_sio_d, cam3_vsync, cam3_href, cam3_pclk, cam3_data, cam3_clk, cam3_sio_c, cam3_sio_d, red_out, green_out, blue_out, vga_vsync, vga_hsync, ddr2_clk, ddr2_clkb, ddr2_cke, ddr2_dqs, ddr2_dqs_n, ddr2_dq, ddr2_csb, ddr2_rasb, ddr2_casb, ddr2_web, ddr2_dm, ddr2_ba, ddr2_address, ddr2_odt, sd_loop_in, sd_loop_out, vgadc_afifo_of, vgadc_afifo_uf, camc_afifo_of, camc_afifo_uf, addr_is_zero, h_v_is_zero, sw0, sw1, sw2, sw3);

`include "./ddr2_cont_parameters.vh"

	input	wire	sysclk;		// U킩50MHzNbN
	input	wire	reset_sw;	// SOUTH SW (T15)
	input	wire	cam1_vsync;	// CMOSJ1VSYNC
	input	wire	cam1_href;	// CMOSJ1HREF
	input	wire	cam1_pclk;	// CMOSJ1pclk
	input	wire	[7:0] cam1_data; // CMOSJ1̃f[^
	output	wire	cam1_clk;	// CMOSJ1̃NbN
	output	wire	cam1_sio_c;	// CMOSJ1SCCBVANbN
	output	wire	cam1_sio_d;	// CMOSJ1SCCBVAf[^
	input	wire	cam3_vsync;	// CMOSJ3VSYNC
	input	wire	cam3_href;	// CMOSJ3HREF
	input	wire	cam3_pclk;	// CMOSJ3pclk
	input	wire	[7:0] cam3_data; // CMOSJ3̃f[^
	output	wire	cam3_clk;	// CMOSJ3̃NbN
	output	wire	cam3_sio_c;	// CMOSJ3SCCBVANbN
	output	wire	cam3_sio_d;	// CMOSJ3SCCBVAf[^
	output	wire	[3:0]	red_out;		// REDo [7:4]̂redo͂ɐڑ
	output	wire	[3:0]	green_out;	// GREENo [7:4]̂greeno͂ɐڑ
	output	wire	[3:0]	blue_out;	// BLUEo [7:4]̂blueo͂ɐڑ
	output	wire	vga_vsync;	// VGAVSYNC
	output	wire	vga_hsync;	// VGAHSYNC
	output	wire	[QUANTITY_OF_CLK_OUTPUT-1 : 0]	ddr2_clk;
	output	wire	[QUANTITY_OF_CLK_OUTPUT-1 : 0]	ddr2_clkb;
	output	wire	ddr2_cke;
	inout	wire	[DDR2_DQS_DM_WIDTH-1 : 0]		ddr2_dqs;
	inout	wire	[DDR2_DQS_DM_WIDTH-1 : 0]		ddr2_dqs_n;
	inout	wire	[DDR2_DATA_WIDTH-1 : 0]			ddr2_dq;
	output	wire	ddr2_csb;
	output	wire	ddr2_rasb;
	output	wire	ddr2_casb;
	output	wire	ddr2_web;
	output	wire	[DDR2_DQS_DM_WIDTH-1 : 0] ddr2_dm;
	output	wire	[1:0] ddr2_ba;
	output	wire	[DDR2_ADDRESS_WIDTH-1 : 0] ddr2_address;
	output	wire	ddr2_odt;
	input	wire	sd_loop_in;
	output	wire	sd_loop_out;
	output	reg		vgadc_afifo_of;	// LEDɐڑ
	output	reg		vgadc_afifo_uf;	// LEDɐڑ
	output	reg		camc_afifo_of;	// LEDɐڑ
	output	reg		camc_afifo_uf;	// LEDɐڑ
	output	wire	addr_is_zero;	// for test LEDɐڑ
	output	wire	h_v_is_zero;	// for test LEDɐڑ
	input	wire	sw0;
	input	wire	sw1;
	input	wire	sw2;
	input	wire	sw3;
	
	wire	clk_ddr2, clk_cam, clk_sdram;
	wire	dcm_cam_ddr2_locked;
	wire	[INTERFACE_DATA_WIDTH-1 : 0] ddr2_input_data;
	// wire	[INTERFACE_MASK_WIDTH-1 : 0] ddr2_input_mask;
	wire	ddr2_read_write;
	wire	[USER_INPUT_ADDRESS_WIDTH-1 : 0] ddr2_input_address;
	wire	[INTERFACE_DATA_WIDTH-1 : 0] ddr2_output_data;
	wire	ddr2_addr_fifo_wren;
	wire	ddr2_wrdata_fifo_wren;
	wire	ddr2_addr_fifo_full;
	wire	ddr2_wrdata_fifo_full;
	wire	ddr2_rddata_valid;
	wire	ddr2_initialize_end;
	
	reg		reset_cam, reset_ddr2;
	reg 	reset_cam_node1, reset_ddr2_node1;
	wire	dcm_locked_out;
	wire	dcm_out_reset;
	
	reg		cam_href_1d, cam_href_2d;
	reg		cam_vsync_1d, cam_vsync_2d;
	reg		[7:0] cam1_data_1d, cam1_data_2d;
	reg		[7:0] cam3_data_1d, cam3_data_2d;
	wire	master_sync;
	
	wire	[18:0]	vgadc_addr;
	wire	vgadc_request, vgadc_grant;
	wire	vgadc_req_we;
	wire	vgadc_afifo_overflow, vgadc_afifo_underflow;
	
	wire	[18:0]	camc_addr;
	wire	[4:0]	camc_afifo_rd_count;
	wire	camc_addr_ena, camc_data_ena;
	wire	camc_afifo_empty;
	wire	camc_afifo_overflow, camc_afifo_underflow;
	wire	[7:0]	ladder_red;		// REDo [7:4]̂redo͂ɐڑ
	wire	[7:0]	ladder_green;	// GREENo [7:4]̂greeno͂ɐڑ
	wire	[7:0]	ladder_blue;	// BLUEo [7:4]̂blueo͂ɐڑ
	wire 	clk_cam_dcm_reset;
	wire	clk_cam_dcm_locked;
	wire	cam_clk_node;
	wire	capture_ena, sw1_out;
	wire	sw2_out, sw3_out;
	wire	cam_sio_c_node, cam_sio_d_node;
	
	dcm_CAM_DDR2_clk dcm_CAM_DDR2_clk_inst(
		.sysclk(sysclk),
		.reset(reset_sw),
		.clk_ddr2(clk_sdram),
		.clk_cam(cam_clk_node),
		.dcm_locked_out(dcm_cam_ddr2_locked)
	);
	
	// cam1_clk o͗pODDR2
	ODDR2 #(
		.DDR_ALIGNMENT("NONE"),
		.INIT(1'b0),
		.SRTYPE("SYNC")
	) CAM1XCLK_inst (
		.Q(cam1_clk),
		.C0(cam_clk_node),
		.C1(~cam_clk_node),
		.CE(1'b1),
		.D0(1'b1),
		.D1(1'b0),
		.R(1'b0),
		.S(1'b0)
	);
	
	// cam3_clk o͗pODDR2
	ODDR2 #(
		.DDR_ALIGNMENT("NONE"),
		.INIT(1'b0),
		.SRTYPE("SYNC")
	) CAM3XCLK_inst (
		.Q(cam3_clk),
		.C0(cam_clk_node),
		.C1(~cam_clk_node),
		.CE(1'b1),
		.D0(1'b1),
		.D1(1'b0),
		.R(1'b0),
		.S(1'b0)
	);
	
	assign clk_cam = cam1_pclk;
	
	ddr2_sdram_cont ddr2_sdram_cont_inst (
		.sysclk(clk_sdram),
		.clk_out(clk_ddr2),
		.reset(~dcm_cam_ddr2_locked),
		.input_data(ddr2_input_data),
		.input_mask(4'b0000),
		.read_write(ddr2_read_write),
		.output_data(ddr2_output_data),
		.input_address(ddr2_input_address),
		.addr_fifo_wren(ddr2_addr_fifo_wren),
		.wrdata_fifo_wren(ddr2_wrdata_fifo_wren),
		.addr_fifo_full(ddr2_addr_fifo_full),
		.wrdata_fifo_full(ddr2_wrdata_fifo_full),
		.rddata_valid(ddr2_rddata_valid),
		.initialize_end(ddr2_initialize_end),
		.dcm_locked_in(dcm_cam_ddr2_locked),
		.dcm_locked_out(dcm_locked_out),
		.ddr2_clk(ddr2_clk),
		.ddr2_clkb(ddr2_clkb),
		.ddr2_cke(ddr2_cke),
		.ddr2_dqs(ddr2_dqs),
		.ddr2_dqs_n(ddr2_dqs_n),
		.ddr2_dq(ddr2_dq),
		.ddr2_csb(ddr2_csb),
		.ddr2_rasb(ddr2_rasb),
		.ddr2_casb(ddr2_casb),
		.ddr2_web(ddr2_web),
		.ddr2_dm(ddr2_dm),
		.ddr2_ba(ddr2_ba),
		.ddr2_address(ddr2_address),
		.ddr2_odt(ddr2_odt),
		.sd_loop_in(sd_loop_in),
		.sd_loop_out(sd_loop_out)
	);
	assign red_out = ladder_red[7:4];
	assign green_out = ladder_green[7:4];
	assign blue_out = ladder_blue[7:4];
	
	Camera_Controller Cam_Cntrler_inst (
		.clk_cam(clk_cam),
		.clk_ddr2(clk_ddr2),
		.reset_cam(reset_cam),
		.reset_ddr2(reset_ddr2),
		.cam_href_2d(cam_href_2d),
		.cam_vsync_2d(cam_vsync_2d),
		.master_sync(master_sync),
		.cam1_data_2d(cam1_data_2d),
		.cam3_data_2d(cam3_data_2d),
		.address(camc_addr),
		.data_out(ddr2_input_data),
		.addr_enable(camc_addr_ena),
		.data_enable(camc_data_ena),
		.capture_ena(capture_ena),
		.afifo_empty(camc_afifo_empty),
		.afifo_rd_data_count(camc_afifo_rd_count),
		.afifo_overflow(camc_afifo_overflow),
		.afifo_underflow(camc_afifo_underflow)
	);
	
	VGA_Display_Controller VGAD_Cntrller_inst (
		.clk_cam(clk_cam),
		.clk_ddr2(clk_ddr2),
		.reset_cam(reset_cam),
		.reset_ddr2(reset_ddr2),
		.request(vgadc_request),
		.grant(vgadc_grant),
		.address(vgadc_addr),
		.req_we(vgadc_req_we),
		.addr_fifo_full(ddr2_addr_fifo_full),
		.data_in(ddr2_output_data),
		.data_valid(ddr2_rddata_valid),
		.red_out(ladder_red),
		.green_out(ladder_green),
		.blue_out(ladder_blue),
		.hsyncx(vga_hsync),
		.vsyncx(vga_vsync),
		.afifo_overflow(vgadc_afifo_overflow),
		.afifo_underflow(vgadc_afifo_underflow),
		.addr_is_zero(addr_is_zero),
		.h_v_is_zero(h_v_is_zero)
	);
	
	Arbiter Arbiter_isnt (
		.clk_ddr2(clk_ddr2),
		.reset_ddr2(reset_ddr2),
		.sw3(sw3_out),
		.sw2(sw2_out),
		.sw1(sw1_out),
		.camc_addr(camc_addr),
		.camc_afifo_empty(camc_afifo_empty),
		.camc_afifo_rd_count(camc_afifo_rd_count),
		.camc_addr_ena(camc_addr_ena),
		.camc_data_ena(camc_data_ena),
		.vgadc_req(vgadc_request),
		.vgadc_gnt(vgadc_grant),
		.vgadc_addr(vgadc_addr),
		.vgadc_addr_we(vgadc_req_we),
		.ddr2_address(ddr2_input_address),
		.ddr2_read_write(ddr2_read_write),
		.ddr2_addr_fifo_wren(ddr2_addr_fifo_wren),
		.ddr2_wrdata_fifo_wren(ddr2_wrdata_fifo_wren),
		.ddr2_addr_fifo_full(ddr2_addr_fifo_full),
		.ddr2_wrdata_fifo_full(ddr2_wrdata_fifo_full)
	);
	
	assign dcm_out_reset = ~dcm_cam_ddr2_locked;
	// reset_cam ̏
	always @(posedge clk_cam, posedge dcm_out_reset) begin
		if (dcm_out_reset) begin
			reset_cam_node1 <= 1'b1;
			reset_cam <= 1'b1;
		end else begin
			reset_cam_node1 <= ~dcm_cam_ddr2_locked | ~ddr2_initialize_end; 
			reset_cam <= reset_cam_node1;
		end
	end
	
	// reset_ddr2 ̏
	always @(posedge clk_ddr2, posedge dcm_out_reset) begin
		if (dcm_out_reset) begin
			reset_ddr2_node1 <= 1'b1;
			reset_ddr2 <= 1'b1;
		end else begin
			reset_ddr2_node1 <= ~dcm_cam_ddr2_locked | ~dcm_locked_out | ~ddr2_initialize_end; 
			reset_ddr2 <= reset_ddr2_node1;
		end
	end
	
	// Camera ̐Mb`
	always @(posedge clk_cam) begin
		if (reset_cam) begin
			cam_href_1d <= 1'b0;
			cam_href_2d <= 1'b0;
			cam_vsync_1d <= 1'b0;
			cam_vsync_2d <= 1'b0;
			cam1_data_1d <= 0;
			cam1_data_2d <= 0;
			cam3_data_1d <= 0;
			cam3_data_2d <= 0;
		end else begin
			cam_href_1d <= cam1_href;
			cam_href_2d <= cam_href_1d;
			cam_vsync_1d <= cam1_vsync;
			cam_vsync_2d <= cam_vsync_1d;
			cam1_data_1d <= cam1_data;
			cam1_data_2d <= cam1_data_1d;
			cam3_data_1d <= cam3_data;
			cam3_data_2d <= cam3_data_1d;
		end
	end
	
	synchronizer synchro_inst (
		.clk(clk_cam),
		.reset(reset_cam),
		.cam_vsync_1d(cam_vsync_1d),
		.cam_href_1d(cam_href_1d),
		.master_sync(master_sync)
	);
	
	// eA񓯊FIFOoverflowunderflowLEDɕ\
	always @(posedge clk_ddr2) begin
		if (reset_ddr2) begin
			camc_afifo_uf <= 1'b0;
			vgadc_afifo_of <= 1'b0;
		end else begin
			if (camc_afifo_underflow)
				camc_afifo_uf <= 1'b1;
			if (vgadc_afifo_overflow)
				vgadc_afifo_of <= 1'b1;
		end
	end
	always @(posedge clk_cam) begin
		if (reset_cam) begin
			camc_afifo_of <= 1'b0;
			vgadc_afifo_uf <= 1'b0;
		end else begin
			if (camc_afifo_overflow)
				camc_afifo_of <= 1'b1;
			if (vgadc_afifo_underflow)
				vgadc_afifo_uf <= 1'b1;
		end
	end
	
	SW_Controller #(
		.frequency_KHz(25000))
	SW_CONT_inst(
		.clk(clk_cam),
		.reset(reset_cam),
		.sw0(sw0),
		.sw1(sw1),
		.sw2(sw2),
		.sw3(sw3),
		.sw0_out(capture_ena),
		.sw1_out(sw1_out),
		.sw2_out(sw2_out),
		.sw3_out(sw3_out)
	);
	
	SCCB_Reg_Controller SCCB_Reg_Cntrler_inst (
		.clk(clk_cam),
		.reset(reset_cam),
		.SCL(cam_sio_c_node),
		.SDA(cam_sio_d_node)
	);
	assign cam1_sio_c = cam_sio_c_node;
	assign cam3_sio_c = cam_sio_c_node;
	assign cam1_sio_d = cam_sio_d_node;
	assign cam3_sio_d = cam_sio_d_node;
		
endmodule

`default_nettype wire
